Bug 6713 - resizing SVG with blur filter is incredibly slow
Summary: resizing SVG with blur filter is incredibly slow
Status: RESOLVED FIXED
Alias: None
Product: WebKit
Classification: Unclassified
Component: SVG (show other bugs)
Version: 420+
Hardware: Macintosh OS X 10.4
: P2 Normal
Assignee: Nobody
URL: http://jan.kollhof.net/projects/svg/e...
Keywords: InRadar, NeedsReduction, ReviewedForRadar, SVGHitList
Depends on: 7207
Blocks: 68469 26389
  Show dependency treegraph
 
Reported: 2006-01-22 03:32 PST by Eric Seidel (no email)
Modified: 2014-05-12 05:54 PDT (History)
5 users (show)

See Also:


Attachments
Slightly reduced testcase (5.11 KB, image/svg+xml)
2006-04-27 02:33 PDT, Alex Taylor
no flags Details

Note You need to log in before you can comment on or make changes to this bug.
Description Eric Seidel (no email) 2006-01-22 03:32:30 PST
Resizing Safari window sends CoreImage off the deep end

http://jan.kollhof.net/projects/svg/examples/aqua.svg

We need to reduce this to the minimal crashing SVG.  At which point we can either fix it in WebKit, or I can take that knowledge to the CoreImage team.
Comment 1 Eric Seidel (no email) 2006-01-26 16:20:17 PST
This is a reproducible crasher for SVG.  Adding to the SVGHitList.
Comment 2 Eric Seidel (no email) 2006-01-26 16:42:07 PST
Also now in Radar:
<rdar://problem/4423939> Resizing Safari window sends Core Image off the deep end
Comment 3 Eric Seidel (no email) 2006-01-29 06:23:48 PST
The situation is much better now.  I discovered as part of fixing http://bugzilla.opendarwin.org/show_bug.cgi?id=6849 that every time we requested a filter object, we were adding it's filter elements onto the filter stack.   This caused us to quickly build a filter stack larger than core image could handle.  The performance is still poor, but much better.
Comment 4 Gregory Block 2006-02-01 02:16:20 PST
... is it just me, or are some effects being added on each time I resize this?  Nightly from the 31st...  Is that related to this?
Comment 5 Joost de Valk (AlthA) 2006-02-04 10:50:30 PST
Performance for resizing this is hellish, but it works and it's consistent it seems....
Comment 6 Alexander Kellett 2006-02-12 10:00:22 PST
as altha points out, while horribly slow this is no longer a hang.
renaming to reflect this, decreasing priority, and removing from hitlist.
Comment 7 Alexander Kellett 2006-02-14 01:48:07 PST
making hitlist again, we are too slow to ship
Comment 8 Alex Taylor 2006-04-27 02:33:08 PDT
Created attachment 7995 [details]
Slightly reduced testcase

It appears the Gaussian blur effect is causing a dramatic slow down.

Slight butchering/reduction of the SVG while still exhibiting the behaviour.
Removed buttons, text and gradient effects, leaving enough gaussian blurred objects.
Comment 9 Gavin Sherlock 2008-08-01 06:20:42 PDT
I see a little CPU usage when resizing the window when visiting:

http://jan.kollhof.net/projects/svg/examples/aqua.svg

but no performance problems.  Maybe should be closed?
Comment 10 Gavin Sherlock 2008-08-01 06:21:31 PDT
Forgot to say - tested with r35417
Comment 11 Dirk Schulze 2009-10-09 13:59:02 PDT
We can close this bug with the new implementation landed with r49402. Needs filters enabled build.